#ifndef INTERACTABLEDECORATIVEOBJECT_HPP_INCLUDED
#define INTERACTABLEDECORATIVEOBJECT_HPP_INCLUDED

#include "../../Core/Classes/DecorativeObject.hpp"
#include "../../Core/Classes/ObjectInfo.hpp"
#include "../../Core/Types/Tile.hpp"
#include "../../Core/Types/Point.hpp"
#include "../../Core/Types/Convex.hpp"
#include <cstdint>

namespace Interactable
{
    class DecorativeObject : public Internal::DecorativeObject
    {
        public:
            DecorativeObject(const Internal::DecorativeObject& G);
            DecorativeObject(const DecorativeObject& G);

            std::int32_t GetID() const;
            std::string GetName() const;
            Tile GetTile() const;
            Internal::ObjectInfo GetInfo() const;
            std::vector<Point> GetModel() const;
            Convex GetConvex() const;

            operator Internal::DecorativeObject() const;
    };
}


#endif // INTERACTABLEDECORATIVEOBJECT_HPP_INCLUDED
