#ifndef INTERACTABLEGROUNDOBJECT_HPP_INCLUDED
#define INTERACTABLEGROUNDOBJECT_HPP_INCLUDED

#include "../../Core/Classes/GroundObject.hpp"
#include "../../Core/Classes/ObjectInfo.hpp"
#include "../../Core/Types/Tile.hpp"
#include "../../Core/Types/Point.hpp"
#include "../../Core/Types/Convex.hpp"
#include <cstdint>

namespace Interactable
{
    class GroundObject : public Internal::GroundObject
    {
        public:
            GroundObject(const Internal::GroundObject& G);
            GroundObject(const GroundObject& G);

            std::int32_t GetID() const;
            std::string GetName() const;
            Tile GetTile() const;
            Internal::ObjectInfo GetInfo() const;
            std::vector<Point> GetModel() const;
            Convex GetConvex() const;

            operator Internal::GroundObject() const;
    };
}

#endif // INTERACTABLEGROUNDOBJECT_HPP_INCLUDED
