#ifndef NPCS_HPP_INCLUDED
#define NPCS_HPP_INCLUDED

#include "../../Core/Classes/NPC.hpp"
#include "../../Core/Types/Tile.hpp"
#include "../../Core/Types/Convex.hpp"
#include <functional>
#include <cstdint>
#include <vector>
#include <string>


/** @addtogroup Models
* @{ */
class NPCs
{
    public:
        static std::vector<Internal::NPC> GetAll();
        static std::vector<Internal::NPC> GetAll(const Tile& Tile);
        static std::vector<Internal::NPC> GetAll(std::int32_t ID);
        static std::vector<Internal::NPC> GetAll(const std::string& Name);
        static std::vector<Internal::NPC> GetAll(const std::vector<std::int32_t>& IDs);
        static std::vector<Internal::NPC> GetAll(const std::vector<std::string>& Names);
        static std::vector<Internal::NPC> GetAll(const std::function<bool (Internal::NPC&)>& Filter);

        static Internal::NPC Get();
        static Internal::NPC Get(const Tile& Tile);
        static Internal::NPC Get(std::int32_t ID);
        static Internal::NPC Get(const std::string& Name);
        static Internal::NPC Get(const std::vector<std::int32_t>& IDs);
        static Internal::NPC Get(const std::vector<std::string>& Names);
        static Internal::NPC Get(const std::function<bool (Internal::NPC&)>& Filter);

        static Tile GetTileOf(const Internal::NPC& NPC);

        static Convex GetConvexOf(const Internal::NPC& NPC);
};
/** @} */

#endif // NPCS_HPP_INCLUDED
