#ifndef PLAYERS_HPP_INCLUDED
#define PLAYERS_HPP_INCLUDED

#include "../../Core/Classes/Player.hpp"
#include "../../Core/Types/Tile.hpp"
#include "../../Core/Types/Convex.hpp"
#include <functional>
#include <cstdint>
#include <vector>
#include <string>

/** @addtogroup Models
* @{ */
class Players
{
    public:
        static Internal::Player GetLocal();
        static std::vector<Internal::Player> GetAll();
        static std::vector<Internal::Player> GetAll(const Tile& Tile);
        static std::vector<Internal::Player> GetAll(const std::string& Name);
        static std::vector<Internal::Player> GetAll(const std::vector<std::string>& Names);
        static std::vector<Internal::Player> GetAll(const std::function<bool (Internal::Player&)>& Filter);

        static Internal::Player Get();
        static Internal::Player Get(const Tile& Tile);
        static Internal::Player Get(const std::string& Name);
        static Internal::Player Get(const std::vector<std::string>& Names);
        static Internal::Player Get(const std::function<bool (Internal::Player&)>& Filter);

        static Tile GetTileOf(const Internal::Player& P);

        static Convex GetConvexOf(const Internal::Player& P);
};

/** @} */

#endif // PLAYERS_HPP_INCLUDED
